-- name: \\#FFA987\\An Ordinary Coop Mod
-- incompatible: romhack
-- pausable: false

gLevelValues.pauseExitAnywhere = false
--gLevelValues.entryLevel = LEVEL_TTC

gGlobalSyncTable.unSwapPoints = 0

INITIAL_MAX_POINTS = 25

gGlobalSyncTable.unSwapPointsMax = INITIAL_MAX_POINTS
gGlobalSyncTable.removeStarsOnDeath = true

gGlobalSyncTable.isSwapped = false
gGlobalSyncTable.swapTimer = 0

gGlobalSyncTable.spawnEntity = false

SPAWN_DIST_TO_MARIO = 1200

gGlobalSyncTable.entitySpeed = 15

SWAP_TIMER_MAX = 1500
SWAP_TIMER_LIMIT = SWAP_TIMER_MAX

PACKET_UPDATE_STARS = 0
PACKET_PLAY_SOUND = 1

swappedTextures = false
local trans = sequence_player_get_transposition(SEQ_PLAYER_LEVEL)
local tempo = sequence_player_get_tempo(SEQ_PLAYER_LEVEL)

local npl = gNetworkPlayers

local noShitsAllowed = {
    [LEVEL_CASTLE_GROUNDS] = true,
    [LEVEL_CASTLE] = true,
    [LEVEL_CASTLE_COURTYARD] = true,
    [LEVEL_BOWSER_1] = true,
    [LEVEL_BOWSER_2] = true,
    [LEVEL_BOWSER_3] = true,
}

define_custom_obj_fields({
    oOwner = "u32"
})

MODEL_SHITILIZER = smlua_model_util_get_id("shit_geo")

local function set_mario_anim_to_obj(o, anim)
    o.header.gfx.animInfo.curAnim = get_mario_vanilla_animation(anim)
end

local function shitilizer_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE

    local hitbox = get_temp_object_hitbox()
    hitbox.height = 90
    hitbox.radius = 90
    hitbox.damageOrCoinValue = 90
    hitbox.interactType = INTERACT_DAMAGE
    obj_set_hitbox(o, hitbox)

    o.globalPlayerIndex = o.oOwner

    network_init_object(o, true, {"oOwner", "oPosX", "oPosY", "oPosZ", "globalPlayerIndex"})
end

local function obj_mark_for_deletion_on_sync(o)
    if npl[0].currAreaSyncValid then obj_mark_for_deletion(o) end
end

local function active_player(m, np)
    -- check if this player is connected and in the same level
    if not np.connected or np.currCourseNum ~= npl[0].currCourseNum or np.currActNum ~= npl[0].currActNum or np.currLevelNum ~= npl[0].currLevelNum or
        np.currAreaIndex ~= npl[0].currAreaIndex then
        return false
    end
    return is_player_active(m)
end

local function object_step_no_collision(o)
    o.oPosX = o.oPosX + o.oForwardVel * sins(o.oMoveAngleYaw)
    o.oPosZ = o.oPosZ + o.oForwardVel * coss(o.oMoveAngleYaw)
    o.oPosY = o.oPosY + o.oVelY
end

local function shitilizer_loop(o)
    local np = network_player_from_global_index(o.oOwner)
    local localID = np.localIndex
    local m = gMarioStates[localID]

    o.oAnimState = 0

    if np == nil then
        obj_mark_for_deletion_on_sync(o)
        return
    end

    if not active_player(m, np) or not gGlobalSyncTable.isSwapped or m.health <= 0xFF or noShitsAllowed[np.currLevelNum] then
        obj_mark_for_deletion_on_sync(o)
        spawn_mist_particles()
        return
    end

    object_step_no_collision(o)

    local player = m.marioObj
    if (player) then
        local sp34 = player.header.gfx.pos.x - o.oPosX
        local sp30 = player.header.gfx.pos.y + 120.0 - o.oPosY
        local sp2C = player.header.gfx.pos.z - o.oPosZ
        local sp2A = atan2s(math.sqrt(sqr(sp34) + sqr(sp2C)), sp30)

        obj_turn_toward_object(o, player, 16, 0x1000)
        o.oMoveAnglePitch = approach_s16_symmetric(o.oMoveAnglePitch, sp2A, 0x1000)
    end

    set_mario_anim_to_obj(o, MARIO_ANIM_WING_CAP_FLY)

    o.oFaceAngleYaw = obj_turn_toward_object(o, m.marioObj, 16, 0x1000)
    o.oFaceAnglePitch = -2730

    o.oVelY = sins(o.oMoveAnglePitch) * gGlobalSyncTable.entitySpeed
    o.oForwardVel = coss(o.oMoveAnglePitch) * gGlobalSyncTable.entitySpeed
end

id_bhvShitilizer = hook_behavior(nil, OBJ_LIST_GENACTOR, true, shitilizer_init, shitilizer_loop, "bhvShitilizer")

local function switch(m, enable)
    swappedTextures = enable
    change_every_texture(not enable)
    
    if enable then
        trans = sequence_player_get_transposition(SEQ_PLAYER_LEVEL) - 6
        tempo = sequence_player_get_tempo(SEQ_PLAYER_LEVEL) - (30 * 48)
        sequence_player_set_transposition(SEQ_PLAYER_LEVEL, trans)
        sequence_player_set_tempo(SEQ_PLAYER_LEVEL, tempo)

        set_skybox_color(0, 50)
        set_skybox_color(1, 50)
        set_skybox_color(2, 50)
        set_fog_intensity(1.1)
        set_override_skybox(BACKGROUND_GREEN_SKY)

        local x = m.pos.x + (-SPAWN_DIST_TO_MARIO * sins(m.faceAngle.y))
        local z = m.pos.z + (-SPAWN_DIST_TO_MARIO * coss(m.faceAngle.y))

        if gGlobalSyncTable.spawnEntity then
            spawn_sync_object(id_bhvShitilizer, MODEL_SHITILIZER, x, m.pos.y, z, function (shit)
                shit.oOwner = npl[0].globalIndex
            end)
        end
    else
        sequence_player_set_transposition(SEQ_PLAYER_LEVEL, trans + 6)
        sequence_player_set_tempo(SEQ_PLAYER_LEVEL, tempo + (30 * 48))

        set_skybox_color(0, 255)
        set_skybox_color(1, 255)
        set_skybox_color(2, 255)
        set_fog_intensity(1)

        set_override_skybox(-1)
    end
end

local function mario_update(m)
    if m.playerIndex ~= 0 then return end
    local isSwapped = gGlobalSyncTable.isSwapped
    
    if isSwapped and not swappedTextures then
        switch(m, true)
    elseif not isSwapped and swappedTextures then
        switch(m, false)
    end

    if isSwapped then
        if m.health > 0x180 then
            m.health = 0x180
        end
    end
end

local function on_sync_valid()
    if gGlobalSyncTable.isSwapped then

        local m = gMarioStates[0]

        switch(m, true)
    end
end

local function update()
    if network_is_server() and not gGlobalSyncTable.isSwapped then
        gGlobalSyncTable.unSwapPointsMax = INITIAL_MAX_POINTS + (INITIAL_MAX_POINTS * ((network_player_connected_count() - 1) * 0.75))
        gGlobalSyncTable.swapTimer = gGlobalSyncTable.swapTimer + 1
        if gGlobalSyncTable.swapTimer >= SWAP_TIMER_LIMIT then
            gGlobalSyncTable.isSwapped = true
            gGlobalSyncTable.swapTimer = 0
            SWAP_TIMER_LIMIT = SWAP_TIMER_MAX
            play_sound(SOUND_OBJ_EEL_2, gGlobalSoundSource)
            network_send(true, { id = PACKET_PLAY_SOUND, param = SOUND_OBJ_EEL_2})
        end
    end
end

local function delete_random_star()
    if not gGlobalSyncTable.removeStarsOnDeath then return end
    local file = get_current_save_file_num() - 1
    local validCourses = {}

    for i = 0, COURSE_MAX - 1 do
        local starFlags = save_file_get_star_flags(file, i - 1)
        if starFlags & ~0x80 ~= 0 then
            table.insert(validCourses, {course = i, flags = starFlags})
        end
    end

    if #validCourses > 0 then
        local selectedCourse = validCourses[math.random(#validCourses)]
        local course = selectedCourse.course
        local starFlags = selectedCourse.flags
        local starNum = math.random(0, 6)

        for _ = 0, 6 do
            if starFlags & (1 << starNum) ~= 0 then
                save_file_remove_star_flags(file, course - 1, (1 << starNum))
                break
            end
            starNum = (starNum + 1) % 7
        end
    end

    save_file_do_save(get_current_save_file_num() - 1, 1)
    update_all_mario_stars()
    network_send(true, { id = PACKET_UPDATE_STARS })
end

local function packet_update_stars()
    update_all_mario_stars()
end

local function packet_play_sound(data)
    play_sound(data.param, gGlobalSoundSource)
end

function on_screen_trans(transition)
    local m = gMarioStates[0]
    if gGlobalSyncTable.isSwapped and (transition == WARP_TRANSITION_FADE_INTO_BOWSER or (m.floor.type == SURFACE_DEATH_PLANE and m.pos.y < m.floorHeight + 2048)) then
        for _ = 0, 1 do
            delete_random_star()
        end
    end
end

local sPackets = {
    [PACKET_UPDATE_STARS] = packet_update_stars,
    [PACKET_PLAY_SOUND] = packet_play_sound,
}

---@param data table
function on_packet_recieve(data)
    if sPackets[data.id] then
        sPackets[data.id](data)
    end
end

local function allow_interact(m, o, intType)
    if m.playerIndex ~= 0 then return end

    local isSwapped = gGlobalSyncTable.isSwapped

    if intType == INTERACT_STAR_OR_KEY then
        return not isSwapped
    elseif intType == INTERACT_COIN and isSwapped then
        local unSwapPoints = gGlobalSyncTable.unSwapPoints + o.oDamageOrCoinValue
        gGlobalSyncTable.unSwapPoints = unSwapPoints

        if unSwapPoints >= gGlobalSyncTable.unSwapPointsMax then
            gGlobalSyncTable.isSwapped = false
            gGlobalSyncTable.unSwapPoints = 0
            play_sound(SOUND_GENERAL_STAR_APPEARS, gGlobalSoundSource)
            network_send(true, {id = PACKET_PLAY_SOUND, param = SOUND_GENERAL_STAR_APPEARS})
        end

        return true
    end
end

hook_event(HOOK_ALLOW_INTERACT, allow_interact)
hook_event(HOOK_ON_PACKET_RECEIVE, on_packet_recieve)
hook_event(HOOK_ON_SCREEN_TRANSITION, on_screen_trans)
hook_event(HOOK_UPDATE, update)
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SYNC_VALID, on_sync_valid)

--* there is no easy way to change all textures..
---@param reset boolean
function change_every_texture(reset)
    if not reset then

        -- BBH
        texture_override_set("spooky_09000000", get_texture_info("custom-bbh_textures.00000.rgba16"))
        texture_override_set("spooky_09000800", get_texture_info("custom-bbh_textures.00800.rgba16"))
        texture_override_set("spooky_09001800", get_texture_info("custom-bbh_textures.01800.rgba16"))
        texture_override_set("spooky_09002800", get_texture_info("custom-bbh_textures.02800.rgba16"))
        texture_override_set("spooky_09003800", get_texture_info("custom-bbh_textures.03800.rgba16"))
        texture_override_set("spooky_09004800", get_texture_info("custom-bbh_textures.04800.rgba16"))
        texture_override_set("spooky_09005000", get_texture_info("custom-bbh_textures.05000.rgba16"))
        texture_override_set("spooky_09006000", get_texture_info("custom-bbh_textures.06000.rgba16"))
        texture_override_set("spooky_09006800", get_texture_info("custom-bbh_textures.06800.rgba16"))
        texture_override_set("spooky_09007000", get_texture_info("custom-bbh_textures.07000.rgba16"))
        texture_override_set("spooky_09008000", get_texture_info("custom-bbh_textures.08000.rgba16"))
        texture_override_set("spooky_09008800", get_texture_info("custom-bbh_textures.08800.rgba16"))
        texture_override_set("spooky_09009000", get_texture_info("custom-bbh_textures.09000.rgba16"))
        texture_override_set("spooky_0900A000", get_texture_info("custom-bbh_textures.0A000.rgba16"))
        texture_override_set("spooky_0900A800", get_texture_info("custom-bbh_textures.0A800.ia16"))
        texture_override_set("spooky_0900B000", get_texture_info("custom-bbh_textures.0B000.ia16"))
        texture_override_set("spooky_0900B800", get_texture_info("custom-bbh_textures.0B800.ia16"))

        -- BOB
        texture_override_set("generic_09000000", get_texture_info("custom-bob_textures.00000.rgba16"))
        texture_override_set("generic_09000800", get_texture_info("custom-bob_textures.00800.rgba16"))
        texture_override_set("generic_09001000", get_texture_info("custom-bob_textures.01000.rgba16"))
        texture_override_set("generic_09001800", get_texture_info("custom-bob_textures.01800.rgba16"))
        texture_override_set("generic_09002000", get_texture_info("custom-bob_textures.02000.rgba16"))
        texture_override_set("generic_09002800", get_texture_info("custom-bob_textures.02800.rgba16"))
        texture_override_set("generic_09003000", get_texture_info("custom-bob_textures.03000.rgba16"))
        texture_override_set("generic_09003800", get_texture_info("custom-bob_textures.03800.rgba16"))
        texture_override_set("generic_09004000", get_texture_info("custom-bob_textures.04000.rgba16"))
        texture_override_set("generic_09004800", get_texture_info("custom-bob_textures.04800.rgba16"))
        texture_override_set("generic_09005000", get_texture_info("custom-bob_textures.05000.rgba16"))
        texture_override_set("generic_09005800", get_texture_info("custom-bob_textures.05800.rgba16"))
        texture_override_set("generic_09006000", get_texture_info("custom-bob_textures.06000.rgba16"))
        texture_override_set("generic_09007000", get_texture_info("custom-bob_textures.07000.rgba16"))
        texture_override_set("generic_09007800", get_texture_info("custom-bob_textures.07800.rgba16"))
        texture_override_set("generic_09008000", get_texture_info("custom-bob_textures.08000.rgba16"))
        texture_override_set("generic_09008800", get_texture_info("custom-bob_textures.08800.rgba16"))
        texture_override_set("generic_09009000", get_texture_info("custom-bob_textures.09000.rgba16"))
        texture_override_set("generic_09009800", get_texture_info("custom-bob_textures.09800.rgba16"))
        texture_override_set("generic_0900A000", get_texture_info("custom-bob_textures.0A000.rgba16"))
        texture_override_set("generic_0900A800", get_texture_info("custom-bob_textures.0A800.rgba16"))
        texture_override_set("generic_0900B000", get_texture_info("custom-bob_textures.0B000.ia16"))
        --texture_override_set("effect_0B006048", get_texture_info("custom-bubble.06048.rgba16"))

        -- CG

        texture_override_set("outside_09000000", get_texture_info("custom-castle_grounds_textures.00000.rgba16"))
        texture_override_set("outside_09000800", get_texture_info("custom-castle_grounds_textures.00800.rgba16"))
        texture_override_set("outside_09001000", get_texture_info("custom-castle_grounds_textures.01000.rgba16"))
        texture_override_set("outside_09002000", get_texture_info("custom-castle_grounds_textures.02000.rgba16"))
        texture_override_set("outside_09003000", get_texture_info("custom-castle_grounds_textures.03000.rgba16"))
        texture_override_set("outside_09003800", get_texture_info("custom-castle_grounds_textures.03800.rgba16"))
        texture_override_set("outside_09004000", get_texture_info("custom-castle_grounds_textures.04000.rgba16"))
        texture_override_set("outside_09004800", get_texture_info("custom-castle_grounds_textures.04800.rgba16"))
        texture_override_set("outside_09005800", get_texture_info("custom-castle_grounds_textures.05800.rgba16"))
        texture_override_set("outside_09006000", get_texture_info("custom-castle_grounds_textures.06000.rgba16"))
        texture_override_set("outside_09006800", get_texture_info("custom-castle_grounds_textures.06800.rgba16"))
        texture_override_set("outside_09007800", get_texture_info("custom-castle_grounds_textures.07800.rgba16"))
        texture_override_set("outside_09008000", get_texture_info("custom-castle_grounds_textures.08000.rgba16"))
        texture_override_set("outside_09008800", get_texture_info("custom-castle_grounds_textures.08800.rgba16"))
        texture_override_set("outside_09009000", get_texture_info("custom-castle_grounds_textures.09000.rgba16"))
        texture_override_set("outside_09009800", get_texture_info("custom-castle_grounds_textures.09800.rgba16"))
        texture_override_set("outside_0900A000", get_texture_info("custom-castle_grounds_textures.0A000.rgba16"))
        texture_override_set("outside_0900A800", get_texture_info("custom-castle_grounds_textures.0A800.rgba16"))
        texture_override_set("outside_0900B000", get_texture_info("custom-castle_grounds_textures.0B000.rgba16"))
        texture_override_set("outside_0900B400", get_texture_info("custom-castle_grounds_textures.0B400.rgba16"))
        texture_override_set("outside_0900BC00", get_texture_info("custom-castle_grounds_textures.0BC00.ia16"))

        -- CCM
        texture_override_set("snow_09000000", get_texture_info("custom-ccm_textures.00000.rgba16"))
        texture_override_set("snow_09000800", get_texture_info("custom-ccm_textures.00800.rgba16"))
        texture_override_set("snow_09001000", get_texture_info("custom-ccm_textures.01000.rgba16"))
        texture_override_set("snow_09002000", get_texture_info("custom-ccm_textures.02000.rgba16"))
        texture_override_set("snow_09002800", get_texture_info("custom-ccm_textures.02800.rgba16"))
        texture_override_set("snow_09003000", get_texture_info("custom-ccm_textures.03000.rgba16"))
        texture_override_set("snow_09003800", get_texture_info("custom-ccm_textures.03800.rgba16"))
        texture_override_set("snow_09004000", get_texture_info("custom-ccm_textures.04000.rgba16"))
        texture_override_set("snow_09004800", get_texture_info("custom-ccm_textures.04800.rgba16"))
        texture_override_set("snow_09005000", get_texture_info("custom-ccm_textures.05000.rgba16"))
        texture_override_set("snow_09005800", get_texture_info("custom-ccm_textures.05800.rgba16"))
        texture_override_set("snow_09006000", get_texture_info("custom-ccm_textures.06000.rgba16"))
        texture_override_set("snow_09006800", get_texture_info("custom-ccm_textures.06800.rgba16"))
        texture_override_set("snow_09007000", get_texture_info("custom-ccm_textures.07000.rgba16"))
        texture_override_set("snow_09008000", get_texture_info("custom-ccm_textures.08000.rgba16"))
        texture_override_set("snow_09008800", get_texture_info("custom-ccm_textures.08800.rgba16"))
        texture_override_set("snow_09009000", get_texture_info("custom-ccm_textures.09000.ia16"))
        texture_override_set("snow_09009800", get_texture_info("custom-ccm_textures.09800.ia16"))
        --texture_override_set("effect_0B000008", get_texture_info("custom-flower.00008.rgba16"))
        --texture_override_set("effect_0B000808", get_texture_info("custom-flower.00808.rgba16"))
        --texture_override_set("effect_0B001008", get_texture_info("custom-flower.01008.rgba16"))
        --texture_override_set("effect_0B001808", get_texture_info("custom-flower.01808.rgba16"))

        texture_override_set("cave_09000000", get_texture_info("custom-hmc_textures.00000.rgba16"))
        texture_override_set("cave_09001000", get_texture_info("custom-hmc_textures.01000.rgba16"))
        texture_override_set("cave_09001800", get_texture_info("custom-hmc_textures.01800.rgba16"))
        texture_override_set("cave_09002800", get_texture_info("custom-hmc_textures.02800.rgba16"))
        texture_override_set("cave_09003000", get_texture_info("custom-hmc_textures.03000.rgba16"))
        texture_override_set("cave_09003800", get_texture_info("custom-hmc_textures.03800.rgba16"))
        texture_override_set("cave_09004800", get_texture_info("custom-hmc_textures.04800.rgba16"))
        texture_override_set("cave_09005800", get_texture_info("custom-hmc_textures.05800.rgba16"))
        texture_override_set("cave_09006800", get_texture_info("custom-hmc_textures.06800.rgba16"))
        texture_override_set("cave_09007000", get_texture_info("custom-hmc_textures.07000.rgba16"))
        texture_override_set("cave_09007800", get_texture_info("custom-hmc_textures.07800.rgba16"))
        texture_override_set("cave_09008800", get_texture_info("custom-hmc_textures.08800.rgba16"))
        texture_override_set("cave_09009800", get_texture_info("custom-hmc_textures.09800.rgba16"))
        texture_override_set("cave_0900A000", get_texture_info("custom-hmc_textures.0A000.rgba16"))
        texture_override_set("cave_0900A800", get_texture_info("custom-hmc_textures.0A800.rgba16"))
        texture_override_set("cave_0900B800", get_texture_info("custom-hmc_textures.0B800.ia16"))
        texture_override_set("cave_0900C000", get_texture_info("custom-hmc_textures.0C000.ia16"))

        texture_override_set("inside_09000000", get_texture_info("custom-inside_castle_textures.00000.rgba16"))
        texture_override_set("inside_09001000", get_texture_info("custom-inside_castle_textures.01000.rgba16"))
        texture_override_set("inside_09002000", get_texture_info("custom-inside_castle_textures.02000.rgba16"))
        texture_override_set("inside_09003000", get_texture_info("custom-inside_castle_textures.03000.rgba16"))
        texture_override_set("inside_09003800", get_texture_info("custom-inside_castle_textures.03800.rgba16"))
        texture_override_set("inside_09004000", get_texture_info("custom-inside_castle_textures.04000.rgba16"))
        texture_override_set("inside_09004800", get_texture_info("custom-inside_castle_textures.04800.rgba16"))
        texture_override_set("inside_09005000", get_texture_info("custom-inside_castle_textures.05000.rgba16"))
        texture_override_set("inside_09005800", get_texture_info("custom-inside_castle_textures.05800.rgba16"))
        texture_override_set("inside_09006000", get_texture_info("custom-inside_castle_textures.06000.rgba16"))
        texture_override_set("inside_09007000", get_texture_info("custom-inside_castle_textures.07000.rgba16"))
        texture_override_set("inside_09008000", get_texture_info("custom-inside_castle_textures.08000.rgba16"))
        texture_override_set("inside_09008800", get_texture_info("custom-inside_castle_textures.08800.rgba16"))
        texture_override_set("inside_09009000", get_texture_info("custom-inside_castle_textures.09000.rgba16"))
        texture_override_set("inside_0900A000", get_texture_info("custom-inside_castle_textures.0A000.rgba16"))
        texture_override_set("inside_0900B000", get_texture_info("custom-inside_castle_textures.0B000.rgba16"))
        texture_override_set("inside_0900B800", get_texture_info("custom-inside_castle_textures.0B800.rgba16"))

        texture_override_set("water_09000000", get_texture_info("custom-jrb_textures.00000.rgba16"))
        texture_override_set("water_09000800", get_texture_info("custom-jrb_textures.00800.rgba16"))
        texture_override_set("water_09001800", get_texture_info("custom-jrb_textures.01800.rgba16"))
        texture_override_set("water_09002800", get_texture_info("custom-jrb_textures.02800.rgba16"))
        texture_override_set("water_09003800", get_texture_info("custom-jrb_textures.03800.rgba16"))
        texture_override_set("water_09004800", get_texture_info("custom-jrb_textures.04800.rgba16"))
        texture_override_set("water_09005800", get_texture_info("custom-jrb_textures.05800.rgba16"))
        texture_override_set("water_09006000", get_texture_info("custom-jrb_textures.06000.rgba16"))
        texture_override_set("water_09006800", get_texture_info("custom-jrb_textures.06800.rgba16"))
        texture_override_set("water_09007800", get_texture_info("custom-jrb_textures.07800.rgba16"))
        texture_override_set("water_09008800", get_texture_info("custom-jrb_textures.08800.rgba16"))
        texture_override_set("water_09009000", get_texture_info("custom-jrb_textures.09000.rgba16"))
        texture_override_set("water_0900A000", get_texture_info("custom-jrb_textures.0A000.rgba16"))
        texture_override_set("water_0900A800", get_texture_info("custom-jrb_textures.0A800.rgba16"))
        texture_override_set("water_0900B800", get_texture_info("custom-jrb_textures.0B800.rgba16"))

        --texture_override_set("effect_0B002020", get_texture_info("custom-lava_bubble.02020.rgba16"))
        --texture_override_set("effect_0B002820", get_texture_info("custom-lava_bubble.02820.rgba16"))
        --texture_override_set("effect_0B003020", get_texture_info("custom-lava_bubble.03020.rgba16"))
        --texture_override_set("effect_0B003820", get_texture_info("custom-lava_bubble.03820.rgba16"))
        --texture_override_set("effect_0B004020", get_texture_info("custom-lava_bubble.04020.rgba16"))
        --texture_override_set("effect_0B004820", get_texture_info("custom-lava_bubble.04820.rgba16"))
        --texture_override_set("effect_0B005020", get_texture_info("custom-lava_bubble.05020.rgba16"))
        --texture_override_set("effect_0B005820", get_texture_info("custom-lava_bubble.05820.rgba16"))

        texture_override_set("fire_09000000", get_texture_info("custom-lll_textures.00000.rgba16"))
        texture_override_set("fire_09000800", get_texture_info("custom-lll_textures.00800.rgba16"))
        texture_override_set("fire_09001000", get_texture_info("custom-lll_textures.01000.rgba16"))
        texture_override_set("fire_09001800", get_texture_info("custom-lll_textures.01800.rgba16"))
        texture_override_set("fire_09002000", get_texture_info("custom-lll_textures.02000.rgba16"))
        texture_override_set("fire_09002800", get_texture_info("custom-lll_textures.02800.rgba16"))
        texture_override_set("fire_09003000", get_texture_info("custom-lll_textures.03000.rgba16"))
        texture_override_set("fire_09003800", get_texture_info("custom-lll_textures.03800.rgba16"))
        texture_override_set("fire_09004000", get_texture_info("custom-lll_textures.04000.rgba16"))
        texture_override_set("fire_09004800", get_texture_info("custom-lll_textures.04800.rgba16"))
        texture_override_set("fire_09005000", get_texture_info("custom-lll_textures.05000.rgba16"))
        texture_override_set("fire_09005800", get_texture_info("custom-lll_textures.05800.rgba16"))
        texture_override_set("fire_09006000", get_texture_info("custom-lll_textures.06000.rgba16"))
        texture_override_set("fire_09006800", get_texture_info("custom-lll_textures.06800.rgba16"))
        texture_override_set("fire_09007000", get_texture_info("custom-lll_textures.07000.rgba16"))
        texture_override_set("fire_09007800", get_texture_info("custom-lll_textures.07800.rgba16"))
        texture_override_set("fire_09008000", get_texture_info("custom-lll_textures.08000.rgba16"))
        texture_override_set("fire_09008800", get_texture_info("custom-lll_textures.08800.rgba16"))
        texture_override_set("fire_09009000", get_texture_info("custom-lll_textures.09000.rgba16"))
        texture_override_set("fire_09009800", get_texture_info("custom-lll_textures.09800.rgba16"))
        texture_override_set("fire_0900A000", get_texture_info("custom-lll_textures.0A000.rgba16"))
        texture_override_set("fire_0900A800", get_texture_info("custom-lll_textures.0A800.rgba16"))
        texture_override_set("fire_0900B000", get_texture_info("custom-lll_textures.0B000.rgba16"))
        texture_override_set("fire_0900B800", get_texture_info("custom-lll_textures.0B800.rgba16"))
        texture_override_set("texture_metal_hole", get_texture_info("custom-metal_hole.rgba16"))

        texture_override_set("sky_09000000", get_texture_info("custom-rr_textures.00000.rgba16"))
        texture_override_set("sky_09000800", get_texture_info("custom-rr_textures.00800.rgba16"))
        texture_override_set("sky_09001000", get_texture_info("custom-rr_textures.01000.rgba16"))
        texture_override_set("sky_09001800", get_texture_info("custom-rr_textures.01800.rgba16"))
        texture_override_set("sky_09002000", get_texture_info("custom-rr_textures.02000.rgba16"))
        texture_override_set("sky_09003000", get_texture_info("custom-rr_textures.03000.rgba16"))
        texture_override_set("sky_09003800", get_texture_info("custom-rr_textures.03800.rgba16"))
        texture_override_set("sky_09004800", get_texture_info("custom-rr_textures.04800.rgba16"))
        texture_override_set("sky_09005000", get_texture_info("custom-rr_textures.05000.rgba16"))
        texture_override_set("sky_09005800", get_texture_info("custom-rr_textures.05800.rgba16"))
        texture_override_set("sky_09006000", get_texture_info("custom-rr_textures.06000.rgba16"))
        texture_override_set("sky_09007000", get_texture_info("custom-rr_textures.07000.rgba16"))
        texture_override_set("sky_09007800", get_texture_info("custom-rr_textures.07800.rgba16"))
        texture_override_set("sky_09008000", get_texture_info("custom-rr_textures.08000.rgba16"))

        --texture_override_set("effect_0B00684C", get_texture_info("custom-tiny_bubble.0684C.rgba16"))
        --texture_override_set("effect_0B006AD8", get_texture_info("custom-tiny_bubble.06AD8.rgba16"))
    
        texture_override_set("machine_09000000", get_texture_info("custom-ttc_textures.00000.rgba16"))
        texture_override_set("machine_09000800", get_texture_info("custom-ttc_textures.00800.rgba16"))
        texture_override_set("machine_09001000", get_texture_info("custom-ttc_textures.01000.rgba16"))
        texture_override_set("machine_09001800", get_texture_info("custom-ttc_textures.01800.rgba16"))
        texture_override_set("machine_09002000", get_texture_info("custom-ttc_textures.02000.rgba16"))
        texture_override_set("machine_09002800", get_texture_info("custom-ttc_textures.02800.rgba16"))
        texture_override_set("machine_09003000", get_texture_info("custom-ttc_textures.03000.rgba16"))
        texture_override_set("machine_09003800", get_texture_info("custom-ttc_textures.03800.rgba16"))
        texture_override_set("machine_09004000", get_texture_info("custom-ttc_textures.04000.rgba16"))
        texture_override_set("machine_09005000", get_texture_info("custom-ttc_textures.05000.rgba16"))
        texture_override_set("machine_09005800", get_texture_info("custom-ttc_textures.05800.rgba16"))
        texture_override_set("machine_09006000", get_texture_info("custom-ttc_textures.06000.rgba16"))
        texture_override_set("machine_09006800", get_texture_info("custom-ttc_textures.06800.rgba16"))
        texture_override_set("machine_09007000", get_texture_info("custom-ttc_textures.07000.rgba16"))
        texture_override_set("machine_09007800", get_texture_info("custom-ttc_textures.07800.rgba16"))
        texture_override_set("machine_09008000", get_texture_info("custom-ttc_textures.08000.rgba16"))
        texture_override_set("machine_09008400", get_texture_info("custom-ttc_textures.08400.rgba16"))

        texture_override_set("mountain_09000000", get_texture_info("custom-ttm_textures.00000.rgba16"))
        texture_override_set("mountain_09000800", get_texture_info("custom-ttm_textures.00800.rgba16"))
        texture_override_set("mountain_09001800", get_texture_info("custom-ttm_textures.01800.rgba16"))
        texture_override_set("mountain_09002800", get_texture_info("custom-ttm_textures.02800.rgba16"))
        texture_override_set("mountain_09003000", get_texture_info("custom-ttm_textures.03000.rgba16"))
        texture_override_set("mountain_09003800", get_texture_info("custom-ttm_textures.03800.rgba16"))
        texture_override_set("mountain_09004000", get_texture_info("custom-ttm_textures.04000.rgba16"))
        texture_override_set("mountain_09004800", get_texture_info("custom-ttm_textures.04800.rgba16"))
        texture_override_set("mountain_09005000", get_texture_info("custom-ttm_textures.05000.rgba16"))
        texture_override_set("mountain_09005800", get_texture_info("custom-ttm_textures.05800.rgba16"))
        texture_override_set("mountain_09006800", get_texture_info("custom-ttm_textures.06800.rgba16"))
        texture_override_set("mountain_09007000", get_texture_info("custom-ttm_textures.07000.rgba16"))
        texture_override_set("mountain_09007800", get_texture_info("custom-ttm_textures.07800.rgba16"))
        texture_override_set("mountain_09008000", get_texture_info("custom-ttm_textures.08000.rgba16"))
        texture_override_set("mountain_09008800", get_texture_info("custom-ttm_textures.08800.rgba16"))
        texture_override_set("mountain_09009800", get_texture_info("custom-ttm_textures.09800.rgba16"))
        texture_override_set("mountain_0900A000", get_texture_info("custom-ttm_textures.0A000.rgba16"))
        texture_override_set("mountain_0900A800", get_texture_info("custom-ttm_textures.0A800.rgba16"))
        texture_override_set("mountain_0900B000", get_texture_info("custom-ttm_textures.0B000.rgba16"))
        texture_override_set("mountain_0900B800", get_texture_info("custom-ttm_textures.0B800.rgba16"))
        texture_override_set("mountain_0900C000", get_texture_info("custom-ttm_textures.0C000.rgba16"))

        texture_override_set("grass_09000000", get_texture_info("custom-wf_textures.00000.rgba16"))
        texture_override_set("grass_09000800", get_texture_info("custom-wf_textures.00800.rgba16"))
        texture_override_set("grass_09001000", get_texture_info("custom-wf_textures.01000.rgba16"))
        texture_override_set("grass_09001800", get_texture_info("custom-wf_textures.01800.rgba16"))
        texture_override_set("grass_09002000", get_texture_info("custom-wf_textures.02000.rgba16"))
        texture_override_set("grass_09002800", get_texture_info("custom-wf_textures.02800.rgba16"))
        texture_override_set("grass_09003000", get_texture_info("custom-wf_textures.03000.rgba16"))
        texture_override_set("grass_09003800", get_texture_info("custom-wf_textures.03800.rgba16"))
        texture_override_set("grass_09004000", get_texture_info("custom-wf_textures.04000.rgba16"))
        texture_override_set("grass_09004800", get_texture_info("custom-wf_textures.04800.rgba16"))
        texture_override_set("grass_09005000", get_texture_info("custom-wf_textures.05000.rgba16"))
        texture_override_set("grass_09005800", get_texture_info("custom-wf_textures.05800.rgba16"))
        texture_override_set("grass_09006000", get_texture_info("custom-wf_textures.06000.rgba16"))
        texture_override_set("grass_09006800", get_texture_info("custom-wf_textures.06800.rgba16"))
        texture_override_set("grass_09007000", get_texture_info("custom-wf_textures.07000.rgba16"))
        texture_override_set("grass_09007800", get_texture_info("custom-wf_textures.07800.rgba16"))
        texture_override_set("grass_09008000", get_texture_info("custom-wf_textures.08000.rgba16"))
        texture_override_set("grass_09008800", get_texture_info("custom-wf_textures.08800.rgba16"))
        texture_override_set("grass_09009000", get_texture_info("custom-wf_textures.09000.rgba16"))
        texture_override_set("grass_09009800", get_texture_info("custom-wf_textures.09800.rgba16"))
        texture_override_set("grass_0900A000", get_texture_info("custom-wf_textures.0A000.rgba16"))
        texture_override_set("grass_0900A800", get_texture_info("custom-wf_textures.0A800.rgba16"))
        texture_override_set("grass_0900B000", get_texture_info("custom-wf_textures.0B000.ia16"))
        texture_override_set("grass_0900B800", get_texture_info("custom-wf_textures.0B800.ia16"))

        texture_override_set("texture_waterbox_water", get_texture_info("custom-segment2.11C58.rgba16"))
        texture_override_set("texture_waterbox_jrb_water", get_texture_info("custom-segment2.12458.rgba16"))
        texture_override_set("texture_waterbox_unknown_water", get_texture_info("custom-segment2.12C58.rgba16"))
        --texture_override_set("texture_waterbox_lava", get_texture_info("custom-segment2.13C58.rgba16"))
    else
        texture_override_reset("spooky_09000000")
        texture_override_reset("spooky_09000800")
        texture_override_reset("spooky_09001800")
        texture_override_reset("spooky_09002800")
        texture_override_reset("spooky_09003800")
        texture_override_reset("spooky_09004800")
        texture_override_reset("spooky_09005000")
        texture_override_reset("spooky_09006000")
        texture_override_reset("spooky_09006800")
        texture_override_reset("spooky_09007000")
        texture_override_reset("spooky_09008000")
        texture_override_reset("spooky_09008800")
        texture_override_reset("spooky_09009000")
        texture_override_reset("spooky_0900A000")
        texture_override_reset("spooky_0900A800")
        texture_override_reset("spooky_0900B000")
        texture_override_reset("spooky_0900B800")

        -- BOB
        texture_override_reset("generic_09000000")
        texture_override_reset("generic_09000800")
        texture_override_reset("generic_09001000")
        texture_override_reset("generic_09001800")
        texture_override_reset("generic_09002000")
        texture_override_reset("generic_09002800")
        texture_override_reset("generic_09003000")
        texture_override_reset("generic_09003800")
        texture_override_reset("generic_09004000")
        texture_override_reset("generic_09004800")
        texture_override_reset("generic_09005000")
        texture_override_reset("generic_09005800")
        texture_override_reset("generic_09006000")
        texture_override_reset("generic_09007000")
        texture_override_reset("generic_09007800")
        texture_override_reset("generic_09008000")
        texture_override_reset("generic_09008800")
        texture_override_reset("generic_09009000")
        texture_override_reset("generic_09009800")
        texture_override_reset("generic_0900A000")
        texture_override_reset("generic_0900A800")
        texture_override_reset("generic_0900B000")
        texture_override_reset("effect_0B006048")

        -- CG

        texture_override_reset("outside_09000000")
        texture_override_reset("outside_09000800")
        texture_override_reset("outside_09001000")
        texture_override_reset("outside_09002000")
        texture_override_reset("outside_09003000")
        texture_override_reset("outside_09003800")
        texture_override_reset("outside_09004000")
        texture_override_reset("outside_09004800")
        texture_override_reset("outside_09005800")
        texture_override_reset("outside_09006000")
        texture_override_reset("outside_09006800")
        texture_override_reset("outside_09007800")
        texture_override_reset("outside_09008000")
        texture_override_reset("outside_09008800")
        texture_override_reset("outside_09009000")
        texture_override_reset("outside_09009800")
        texture_override_reset("outside_0900A000")
        texture_override_reset("outside_0900A800")
        texture_override_reset("outside_0900B000")
        texture_override_reset("outside_0900B400")
        texture_override_reset("outside_0900BC00")

        -- CCM
        texture_override_reset("snow_09000000")
        texture_override_reset("snow_09000800")
        texture_override_reset("snow_09001000")
        texture_override_reset("snow_09002000")
        texture_override_reset("snow_09002800")
        texture_override_reset("snow_09003000")
        texture_override_reset("snow_09003800")
        texture_override_reset("snow_09004000")
        texture_override_reset("snow_09004800")
        texture_override_reset("snow_09005000")
        texture_override_reset("snow_09005800")
        texture_override_reset("snow_09006000")
        texture_override_reset("snow_09006800")
        texture_override_reset("snow_09007000")
        texture_override_reset("snow_09008000")
        texture_override_reset("snow_09008800")
        texture_override_reset("snow_09009000")
        texture_override_reset("snow_09009800")
        texture_override_reset("effect_0B000008")
        texture_override_reset("effect_0B000808")
        texture_override_reset("effect_0B001008")
        texture_override_reset("effect_0B001808")

        texture_override_reset("cave_09000000")
        texture_override_reset("cave_09001000")
        texture_override_reset("cave_09001800")
        texture_override_reset("cave_09002800")
        texture_override_reset("cave_09003000")
        texture_override_reset("cave_09003800")
        texture_override_reset("cave_09004800")
        texture_override_reset("cave_09005800")
        texture_override_reset("cave_09006800")
        texture_override_reset("cave_09007000")
        texture_override_reset("cave_09007800")
        texture_override_reset("cave_09008800")
        texture_override_reset("cave_09009800")
        texture_override_reset("cave_0900A000")
        texture_override_reset("cave_0900A800")
        texture_override_reset("cave_0900B800")
        texture_override_reset("cave_0900C000")

        texture_override_reset("inside_09000000")
        texture_override_reset("inside_09001000")
        texture_override_reset("inside_09002000")
        texture_override_reset("inside_09003000")
        texture_override_reset("inside_09003800")
        texture_override_reset("inside_09004000")
        texture_override_reset("inside_09004800")
        texture_override_reset("inside_09005000")
        texture_override_reset("inside_09005800")
        texture_override_reset("inside_09006000")
        texture_override_reset("inside_09007000")
        texture_override_reset("inside_09008000")
        texture_override_reset("inside_09008800")
        texture_override_reset("inside_09009000")
        texture_override_reset("inside_0900A000")
        texture_override_reset("inside_0900B000")
        texture_override_reset("inside_0900B800")

        texture_override_reset("water_09000000")
        texture_override_reset("water_09000800")
        texture_override_reset("water_09001800")
        texture_override_reset("water_09002800")
        texture_override_reset("water_09003800")
        texture_override_reset("water_09004800")
        texture_override_reset("water_09005800")
        texture_override_reset("water_09006000")
        texture_override_reset("water_09006800")
        texture_override_reset("water_09007800")
        texture_override_reset("water_09008800")
        texture_override_reset("water_09009000")
        texture_override_reset("water_0900A000")
        texture_override_reset("water_0900A800")
        texture_override_reset("water_0900B800")

        texture_override_reset("effect_0B002020")
        texture_override_reset("effect_0B002820")
        texture_override_reset("effect_0B003020")
        texture_override_reset("effect_0B003820")
        texture_override_reset("effect_0B004020")
        texture_override_reset("effect_0B004820")
        texture_override_reset("effect_0B005020")
        texture_override_reset("effect_0B005820")

        texture_override_reset("fire_09000000")
        texture_override_reset("fire_09000800")
        texture_override_reset("fire_09001000")
        texture_override_reset("fire_09001800")
        texture_override_reset("fire_09002000")
        texture_override_reset("fire_09002800")
        texture_override_reset("fire_09003000")
        texture_override_reset("fire_09003800")
        texture_override_reset("fire_09004000")
        texture_override_reset("fire_09004800")
        texture_override_reset("fire_09005000")
        texture_override_reset("fire_09005800")
        texture_override_reset("fire_09006000")
        texture_override_reset("fire_09006800")
        texture_override_reset("fire_09007000")
        texture_override_reset("fire_09007800")
        texture_override_reset("fire_09008000")
        texture_override_reset("fire_09008800")
        texture_override_reset("fire_09009000")
        texture_override_reset("fire_09009800")
        texture_override_reset("fire_0900A000")
        texture_override_reset("fire_0900A800")
        texture_override_reset("fire_0900B000")
        texture_override_reset("fire_0900B800")
        texture_override_reset("texture_metal_hole")

        texture_override_reset("sky_09000000")
        texture_override_reset("sky_09000800")
        texture_override_reset("sky_09001000")
        texture_override_reset("sky_09001800")
        texture_override_reset("sky_09002000")
        texture_override_reset("sky_09003000")
        texture_override_reset("sky_09003800")
        texture_override_reset("sky_09004800")
        texture_override_reset("sky_09005000")
        texture_override_reset("sky_09005800")
        texture_override_reset("sky_09006000")
        texture_override_reset("sky_09007000")
        texture_override_reset("sky_09007800")
        texture_override_reset("sky_09008000")

        texture_override_reset("effect_0B00684C")
        texture_override_reset("effect_0B006AD8")
    
        texture_override_reset("machine_09000000")
        texture_override_reset("machine_09000800")
        texture_override_reset("machine_09001000")
        texture_override_reset("machine_09001800")
        texture_override_reset("machine_09002000")
        texture_override_reset("machine_09002800")
        texture_override_reset("machine_09003000")
        texture_override_reset("machine_09003800")
        texture_override_reset("machine_09004000")
        texture_override_reset("machine_09005000")
        texture_override_reset("machine_09005800")
        texture_override_reset("machine_09006000")
        texture_override_reset("machine_09006800")
        texture_override_reset("machine_09007000")
        texture_override_reset("machine_09007800")
        texture_override_reset("machine_09008000")
        texture_override_reset("machine_09008400")

        texture_override_reset("mountain_09000000")
        texture_override_reset("mountain_09000800")
        texture_override_reset("mountain_09001800")
        texture_override_reset("mountain_09002800")
        texture_override_reset("mountain_09003000")
        texture_override_reset("mountain_09003800")
        texture_override_reset("mountain_09004000")
        texture_override_reset("mountain_09004800")
        texture_override_reset("mountain_09005000")
        texture_override_reset("mountain_09005800")
        texture_override_reset("mountain_09006800")
        texture_override_reset("mountain_09007000")
        texture_override_reset("mountain_09007800")
        texture_override_reset("mountain_09008000")
        texture_override_reset("mountain_09008800")
        texture_override_reset("mountain_09009800")
        texture_override_reset("mountain_0900A000")
        texture_override_reset("mountain_0900A800")
        texture_override_reset("mountain_0900B000")
        texture_override_reset("mountain_0900B800")
        texture_override_reset("mountain_0900C000")

        texture_override_reset("grass_09000000")
        texture_override_reset("grass_09000800")
        texture_override_reset("grass_09001000")
        texture_override_reset("grass_09001800")
        texture_override_reset("grass_09002000")
        texture_override_reset("grass_09002800")
        texture_override_reset("grass_09003000")
        texture_override_reset("grass_09003800")
        texture_override_reset("grass_09004000")
        texture_override_reset("grass_09004800")
        texture_override_reset("grass_09005000")
        texture_override_reset("grass_09005800")
        texture_override_reset("grass_09006000")
        texture_override_reset("grass_09006800")
        texture_override_reset("grass_09007000")
        texture_override_reset("grass_09007800")
        texture_override_reset("grass_09008000")
        texture_override_reset("grass_09008800")
        texture_override_reset("grass_09009000")
        texture_override_reset("grass_09009800")
        texture_override_reset("grass_0900A000")
        texture_override_reset("grass_0900A800")
        texture_override_reset("grass_0900B000")

        texture_override_reset("texture_waterbox_water")
        texture_override_reset("texture_waterbox_jrb_water")
        texture_override_reset("texture_waterbox_unknown_water")
        texture_override_reset("texture_waterbox_lava")
    end
end